unit WebModuleUnit1;

interface

uses
  BookshelfModule,
  Bcl.JOSE.Core.JWT,
  Bcl.JOSE.Core.JWS,
  Bcl.JOSE.Core.JWK,
  Bcl.JOSE.Core.JWA,
  Bcl.JOSE.Types.JSON,
  Bcl.JOSE.Core.Builder,
  GraphQL.WebBroker,
  System.Rtti,
  System.SysUtils,
  System.Classes,
  Sparkle.HttpServer.Module,
  Sparkle.HttpServer.Context,
  Sparkle.Comp.Server,
  Sparkle.Middleware.Jwt,
  Sparkle.Security,
  Sparkle.Module.Static,
  Sparkle.Comp.StaticServer,
  Vcl.Mask,
  Web.HTTPApp,
  WinApi.Windows,
  XData.Server.Module,
  XData.Sys.Exceptions,
  XData.Comp.Server;

type
  TWebModule1 = class(TWebModule)
    GraphQLWebBrokerDispatcher1: TGraphQLWebBrokerDispatcher;
    XDataServer1: TXDataServer;
    SparkleStaticServer1: TSparkleStaticServer;
    procedure WebModuleBeforeDispatch(Sender: TObject; Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure SparkleStaticServer1ModuleCreate(Sender: TObject; Module: TStaticModule);
  private
    FCompact: string;
  public
    { Public declarations }
    function VerifyToken: Boolean;
//    procedure VerifyTokenComplete;
//    procedure VerifyToken;
  end;

var
  WebModuleClass: TComponentClass = TWebModule1;

const
  SHARED_SECRET = 'qwertyuiopasdfghjklzxcvbnm123456';

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TWebModule1 }

procedure TWebModule1.SparkleStaticServer1ModuleCreate(Sender: TObject; Module: TStaticModule);
begin
  Module.AddMiddleware(TJwtMiddleware.Create(SHARED_SECRET));
end;

function TWebModule1.VerifyToken: Boolean;
var
  LToken: TJWT;
begin
  OutputDebugString('execute VerifyToken...');

  Result := False;

  // Unpack and verify the token
  LToken := TJOSE.Verify(SHARED_SECRET, FCompact);

  if Assigned(LToken) then
  begin
    try
      // todo: get "customer_email" from JWT payload and check if it exists in the database.
      // ...

      Result := LToken.Verified;
    finally
      LToken.Free;
    end;
  end;
end;

//procedure TWebModule1.VerifyToken;
//var
//  LToken: TJWT;
//begin
//  // Unpack and verify the token
//  LToken := TJOSE.Verify(SHARED_SECRET, FCompact);
//
//  if Assigned(LToken) then
//  begin
//    try
//      if LToken.Verified then
//        OutputDebugString('Token signature verified, you can trust the claims')
//      else
//        OutputDebugString('Token signature not verified')
//    finally
//      LToken.Free;
//    end;
//  end;
//end;
//
//procedure TWebModule1.VerifyTokenComplete;
//var
//  LKey: TJWK;
//  LToken: TJWT;
//  LSigner: TJWS;
//begin
//  LKey := TJWK.Create(SHARED_SECRET);
//  try
//    LToken := TJWT.Create;
//    try
//      LSigner := TJWS.Create(LToken);
//      try
//        LSigner.SetKey(LKey);
//        LSigner.CompactToken := FCompact;
//
//        if LSigner.VerifySignature then
//          OutputDebugString('Token signature is verified')
//        else
//          OutputDebugString('Token signature is not verified')
//      finally
//        LSigner.Free;
//      end;
//    finally
//      LToken.Free;
//    end;
//  finally
//    LKey.Free;
//  end;
//end;

procedure TWebModule1.WebModuleBeforeDispatch(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
  var Handled: Boolean);
var
//  LCustomerEmail: String;
//  User: IUserIdentity;
  LToken: TJWT;
  LSigner: TJWS;

begin
  OutputDebugString('execute WebModuleBeforeDispatch...');

//  User := TXDataOperationContext.Current.Request.User;
//  if User = nil then
//    raise EXDataHttpUnauthorized.Create('User = nil');
//  if not (User.Claims.Exists('isadmin') and User.Claims['isadmin'].AsBoolean) then
//    raise EXDataHttpForbidden.Create('Not enough privileges');

//  LCustomerEmail := Request.GetFieldByName('customer_email');
//  OutputDebugString(PChar(LCustomerEmail));

  LSigner := TJWS.Create(LToken);
  FCompact := LSigner.CompactToken;

  if VerifyToken then
  //if 1=1 then
  begin
    Handled := True;
  end
  else
  begin
    Handled := False;
  end;

//  LToken := TJOSE.DeserializeCompact(SHARED_SECRET, FCompact);
//  try
//    if Assigned(LToken) then
//      OutputDebugString(pchar(LToken.Claims.JSON.ToJSON));
//  finally
//    LToken.Free;
//  end;
//

//

//
//  VerifyTokenComplete;
//  VerifyToken;
end;

end.
